## mingw-w64-siesta-5.4.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)


# CMAKE_MODULE_PATH is locally searched for *.cmake files
# before CMAKE_PREFIX_PATH.
# We will prefer to use CMAKE_MODULE_PATH
list(PREPEND
  CMAKE_MODULE_PATH
  # add the generic configuration cmake directory
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  # add the external modules directory
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  )

# Define project details
# Add [siesta] to the output
list(APPEND CMAKE_MESSAGE_CONTEXT siesta)
project(
  SIESTA
  LANGUAGES Fortran C
  HOMEPAGE_URL "https://siesta-project.org/siesta"
  DESCRIPTION "A first-principles materials simulation code using DFT."
  )

set(SIESTA_AUTHOR  "Siesta group")
set(SIESTA_LICENSE "GPLv3")
#-----

# Use new rpath behavior
cmake_policy(SET CMP0042 NEW)

# Follow GNU conventions for installing directories
# This will use the bin/ include/ etc. folder structure
include(GNUInstallDirs)

# Include Siesta specific utility functions
include(SiestaUtils)
include(SiestaConda)
include(SiestaPrintBuildInfo)
siesta_util_ensure_out_of_source_build()

if(PROJECT_IS_TOP_LEVEL)
  if(SIESTA_ALLOW_LEGACY_OPTION_NAMES) # Please try to avoid this
    include(SiestaEnableLegacyOptions)
  else()
    include(SiestaBlockLegacyOptions)
  endif()
else()
  message(STATUS "*** Siesta is being configured as a subproject***")
  message(STATUS "CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")
  message(STATUS "PROJECT_SOURCE_DIR: ${PROJECT_SOURCE_DIR}")
  include(SiestaBlockLegacyOptions)
endif()

# Compiler flags
include(SiestaFlags)
include(SiestaCheckFlags)

# -- Options ----------------------------------------

# This is just to have the user choose how to do the build
# generally they don't need to be touched, but it can be useful
# when siesta is used as a submodule.
option(SIESTA_TESTS "Siesta: Build test-suite" ${PROJECT_IS_TOP_LEVEL})
if( SIESTA_TESTS )
  enable_testing()
endif()
option(BUILD_SHARED_LIBS "Siesta: Build using shared libraries" FALSE)
option(SIESTA_SHARED_LIBS "Siesta: Build as a shared library" "${BUILD_SHARED_LIBS}")
if( SIESTA_SHARED_LIBS )
  include(CheckPIESupported)
  check_pie_supported()
  message(STATUS "Enabling position independent code")
  # Ensure BUILD_SHARED_LIBS is set
  set(BUILD_SHARED_LIBS ON CACHE BOOL "Building shared libs" FORCE)
elseif( BUILD_SHARED_LIBS )
  set(BUILD_SHARED_LIBS OFF CACHE BOOL "Building shared libs" FORCE)
endif()

option(SIESTA_SET_RPATH "Siesta: add rpath information to executable and libraries" ON)
if( SIESTA_SET_RPATH )
  message(STATUS "Enabling setting of rpath in installed objects")

  # Common settings
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_INSTALL_RPATH "@loader_path/../${CMAKE_INSTALL_LIBDIR};${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  else()
    # Linux-specific settings
    set(CMAKE_INSTALL_RPATH "\$ORIGIN/../${CMAKE_INSTALL_LIBDIR};${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    # Use RUNPATH instead of RPATH
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--enable-new-dtags")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-new-dtags")
  endif()

endif()

if(SIESTA_HAS_IPO)
  option(SIESTA_WITH_IPO "Siesta: enable IPO/LTO optimization for Siesta targets" FALSE)
  if( SIESTA_WITH_IPO )
    message(STATUS "Enabling IPO/LTO for targets")
  endif()
elseif(SIESTA_WITH_IPO)
  message(FATAL_ERROR [==[
Siesta detected something wrong IPO for your compilers.

Either your default flags are erroneous or IPO simply does not
work with your compiler...

Please reconfigure without -DSIESTA_WITH_IPO
]==])
endif()


option(SIESTA_INSTALL "Siesta: Install project" ${PROJECT_IS_TOP_LEVEL})

# this should be advanced, as it is primarily useful for users of Siesta as a
# sub-project.
mark_as_advanced(BUILD_SHARED_LIBS)
mark_as_advanced(SIESTA_INSTALL SIESTA_TESTS SIESTA_SHARED_LIBS)

option(SIESTA_WITH_GRID_SP "Siesta: Use single-precision for grid magnitudes" FALSE)

option(SIESTA_BUILD_DOCS "Siesta: Create documentation (WIP)" FALSE)
option(SIESTA_WITH_PEXSI "Siesta: Use the PEXSI library (direct interface)" FALSE)
option(SIESTA_WITH_WANNIER90 "Siesta: Use the wannier90 interface" FALSE)
option(SIESTA_WITH_CHESS "Siesta: Use the CheSS linear-scaling library from BigDFT" FALSE)

# If SIESTA_WITH_UNIT_CONVENTION is set as a normal variable by a
# super-project, the normal variable will take precedence in
# principle, but versions of CMake older than 3.21 will *remove* the
# normal variable when executing the set(...CACHE...) statement...  So
# this must be wrapped

if(PROJECT_IS_TOP_LEVEL)
 # Command-line options take precedence over this, since the 'force' option is not
 # given, for obvious reasons
 set(SIESTA_WITH_UNIT_CONVENTION "CODATA2018"
   CACHE STRING
   "Decide which units ${PROJECT_NAME} should be compiled with [original,legacy,codata2018]"
   )
 # Define the available options for cmake-gui
 set_property(CACHE SIESTA_WITH_UNIT_CONVENTION
   PROPERTY STRINGS
   "original" "legacy" "CODATA2018"
 )
# Do not make this public
 mark_as_advanced(SIESTA_WITH_UNIT_CONVENTION)

else()
 if (NOT DEFINED SIESTA_WITH_UNIT_CONVENTION)
  set(SIESTA_WITH_UNIT_CONVENTION "CODATA2018")
 endif()
endif()

# ------------------------------------------------


# Use Pkg-Config if available
# Many of our sub-inclusions requires this one, so we will catch errors here
# To not confuse users!
find_package(PkgConfig REQUIRED)


# -- Version information
message(CHECK_START "Checking Siesta version")
list(APPEND CMAKE_MESSAGE_INDENT "  ")

# Before searching for any versions, we create the required version files
# that can be used to track version information
execute_process(COMMAND sh "${PROJECT_SOURCE_DIR}/Tools/version_generate.sh"
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE SIESTA_VERSION
  RESULT_VARIABLE VERSION_RESULT
  ERROR_VARIABLE VERSION_STDERR)

# fix omission from vgen which sometimes has a newline
string(REGEX REPLACE "\n" " " SIESTA_VERSION "${SIESTA_VERSION}")
string(STRIP "${SIESTA_VERSION}" SIESTA_VERSION)
message(STATUS "SIESTA_VERSION: ${SIESTA_VERSION} (err=${VERSION_RESULT})")
# Pretty print the error content
if(VERSION_RESULT EQUAL 2)
  set(tmp CHECK_FAIL)
  set(tmp_msg "not found")
elseif(VERSION_RESULT EQUAL 3)
  set(tmp CHECK_PASS)
  set(tmp_msg "found development version")
else()
  set(tmp CHECK_PASS)
  set(tmp_msg "found release version")
endif()

message(STATUS "${VERSION_STDERR}")
list(POP_BACK CMAKE_MESSAGE_INDENT)
message(${tmp} "${tmp_msg}")


# Look for blas, if needed, it is not required if LAPACK ships BLAS
find_package(CustomBlas)

# Look for LAPACK
find_package(CustomLapack REQUIRED)

if(NOT TARGET MPI::MPI_Fortran)
 # Find MPI
 find_package(MPI COMPONENTS Fortran)
endif()


# AG: Scalapack-related logic should perhaps be updated

if(MPI_Fortran_FOUND)
  if( NOT DEFINED SIESTA_WITH_MPI)
    find_package(CustomScalapack)
    if( NOT SCALAPACK_FOUND )
      message(WARNING
        "MPI is found, but ScaLAPACK library cannot be found (or compiled against).\n"
        "If parallel support is required please supply the ScaLAPACK library with appropriate "
        "flags:\n"
        " -DSCALAPACK_LIBRARY=<lib>")
      set(MPI_Fortran_FOUND FALSE)
    endif()
  elseif( SIESTA_WITH_MPI )
    find_package(CustomScalapack)
  endif()
endif()

option(SIESTA_WITH_MPI "Build Siesta with MPI support" ${MPI_Fortran_FOUND})

if( SIESTA_WITH_MPI )
  if(NOT MPI_Fortran_FOUND)
    message(WARNING
      "MPI could not be found by CMake"
      "Try setting MPI_Fortran_COMPILER to an MPI wrapper, or the MPI_HOME env variable"
      "If unsuccessful, set -DSIESTA_WITH_MPI=OFF")
    message(FATAL_ERROR "MPI was requested, but could not be found by CMake")
  endif()
  if( NOT SCALAPACK_FOUND )
    message(WARNING
      "ScaLAPACK could not be found by CMake"
      "Try adding SCALAPACK_LIBRARIES with appropriate flags"
      "If ScaLAPACK is not present MPI needs to be turned off:\n"
      "  -DSIESTA_WITH_MPI=OFF"
      )
    message(FATAL_ERROR "MPI was requested, but ScaLAPACK could not be found by CMake")
  endif()


else()
  message(STATUS "MPI is disabled")

  # Add the fakeMPI directory to the include path to ensure it's just working

endif()




# Check for ELSI support
option(SIESTA_WITH_ELSI "Siesta: Use the ELSI library interface" ${SIESTA_WITH_MPI})

# Now we can check for linear algebra stuff
include(SiestaCheckLinalg)
include(SiestaCheckLinalgFeatures)

#---------------------------- OpenMP
# OpenMP *must* be user-requested since it brings additional
# overhead. We should also, for consistency check whether the LAPACK
# and/or BLAS libraries support OpenMP in some form.
# There is little gain when using OpenMP and BLAS libraries are not threaded.
option(SIESTA_WITH_OPENMP "Build with OpenMP support (very few utilities will benefit)" FALSE)
if( SIESTA_WITH_OPENMP )

  if(NOT TARGET OpenMP::OpenMP_Fortran)
    find_package(OpenMP COMPONENTS Fortran C)

    if( OpenMP_FOUND )

      if(NOT OpenMP_Fortran_HAVE_OMPLIB_MODULE)
        message(ERROR_FATAL "OpenMP does not have the 'omp_lib' module used by Siesta OpenMP")
      endif()

    else()
      message(ERROR_FATAL "OpenMP support requested but could not find any OpenMP flags")
    endif()
  endif()

endif()

# NETCDF -- First, a fault check for case-sensitive arguments
# Instead of relying on multiple variants, we should just
# kill the build.
# The problem is that NetCDF *may* require additional
# variables in correct case format. And if we allow upper-case
# for the _ROOT variable, we should do so for all of the variables
# which turns out to be a mess... (we can do a loop if we have everything,
# but for now lets not do this.
foreach(name IN ITEMS "PATH" "ROOT")
  if( (DEFINED NETCDF_${name}) AND (NOT DEFINED NetCDF_${name}) )
    message(WARNING
      "Searching for NetCDF requires the correct case of the search."
      "The build script detected that NETCDF_${name} is defined whereas "
      "NetCDF_${name} is not defined.\n"
      "The search for the NetCDF library requires that you use the "
      "NetCDF_* format for variables. E.g. do this:\n"
      " -DNetCDF_${name}=${NETCDF_${name}}\n"
      "on the command-line instead.")
    message(FATAL_ERROR "Wrong case-notation of NetCDF search variables.")
  endif()
endforeach()

find_package(NetCDF 4.0.0 COMPONENTS Fortran C)

message(DEBUG "NetCDF_Fortran_INCLUDE_DIRS: ${NetCDF_Fortran_INCLUDE_DIRS}")
message(DEBUG "NetCDF_C_INCLUDE_DIRS: ${NetCDF_C_INCLUDE_DIRS}")

if (DEFINED SIESTA_WITH_NetCDF AND (NOT DEFINED SIESTA_WITH_NETCDF))
  message(FATAL_ERROR "Please use SIESTA_WITH_NETCDF and not SIESTA_WITH_NetCDF as the option name")
endif()

option(SIESTA_WITH_NETCDF "Build Siesta with NetCDF support" ${NetCDF_Fortran_FOUND})

if (SIESTA_WITH_NETCDF AND (NOT NetCDF_Fortran_FOUND))
  message(WARNING
    "NetCDF_Fortran is requested but could not be found by CMake.\n"
    "Try setting variables these variables for searching:\n"
    " - NetCDF_ROOT or NetCDF_PATH\n"
    " - NetCDF_INCLUDE_DIR or NetCDF_Fortran_INCLUDE_DIR\n"
    " - NetCDF_INCLUDE_DIRS or NetCDF_Fortran_INCLUDE_DIRS\n"
    "to appropriate variables for discovering NetCDF fortran libraries."
    "Another possibility would be to add the NetCDF cmake package path to\n"
    "  CMAKE_PREFIX_PATH\n"
    "for automatic discovery."
    "If still unsuccessful, please disable NetCDF support with:\n"
    "  -DSIESTA_WITH_NETCDF=OFF\n")
  message(FATAL_ERROR "NetCDF could not be found by CMake")
endif()

option(SIESTA_WITH_NCDF "Use the NCDF library" ${SIESTA_WITH_NETCDF})


if( SIESTA_WITH_NETCDF )

  if (SIESTA_WITH_MPI)
    # Note that MPI must be enabled for this to make sense
    option(SIESTA_WITH_NCDF_PARALLEL "Use NCDF_PARALLEL" ${NetCDF_PARALLEL})
  else()
    option(SIESTA_WITH_NCDF_PARALLEL "Use NCDF_PARALLEL" FALSE)
  endif()

else()

=== Docs/CMakeLists.txt ===
#
# Logic taken from SIRIUS distribution
#
#
# Doxygen version of the documentation
#
if( NOT SIESTA_BUILD_DOCS )
  return()
endif()

find_package(Doxygen)

if( DOXYGEN_FOUND )

  set(DOXYGEN_CONFIG_FILE "${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg")
  # configure doxygen.cfg.in and adapt paths
  configure_file(doxygen.cfg.in ${DOXYGEN_CONFIG_FILE} @ONLY IMMEDIATE)

  set(DOXYGEN_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}")
  # Add a target and build doc with all targets
  add_custom_target(doc-doxygen ALL
     COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_CONFIG_FILE}
     WORKING_DIRECTORY ${DOXYGEN_OUTPUT_DIR}
   )
  install(
    DIRECTORY ${DOXYGEN_OUTPUT_DIR}/html/
    DESTINATION ${CMAKE_INSTALL_PREFIX}/doc/doxygen
  )
endif()

#
# FORD version of the documentation
#
# Some modern versions of FORD are unable to process correctly the
# inter-page links. Treat this as work-in-progress
#
find_program(FORD_EXE ford
  DOC "path to the ford executable (required to generate the documentation)"
)
if( FORD_EXE )

  # Copy the FORD project-file into the build directory
  set(FORD_PROJECT_FILE "${CMAKE_CURRENT_BINARY_DIR}/ford-siesta.md")
  set(FORD_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc-ford-build")
  configure_file(ford.cfg.in "${FORD_PROJECT_FILE}" @ONLY)

  add_custom_target(doc-ford
    COMMENT "Generating API documentation"
    COMMAND "${FORD_EXE}" "${FORD_PROJECT_FILE}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    VERBATIM
  )
  install(
    DIRECTORY "${FORD_OUTPUT_DIR}/"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/doc/ford
  )

endif()

=== Src/CMakeLists.txt ===
set(libsiesta_sources

  Fstack.T90
  Pair.T90
  alloc.F90
  alloc_handlers_m.F90
  amn.F90
  arw.f
  atm_types.f
  atmfuncs.f
  atmparams.f
  atom.F
  atom_graph.F90
  atom_options.F90
  atomlist.f
  atomlwf.F
  automatic_cell.f
  bands.F
  basic_func.inc
  basic_type.inc
  basis_enthalpy.f90
  basis_io.F
  basis_specs.f
  basis_types.f
  bessph.f
  bloch_unfold.F90
  bonds.f
  born_charge.F
  broadcast_basis.F
  broadcast_fdf_struct.F90
  broadcast_projections.F
  broyden_optim.F
  bsc_cellxc.F
  byte_count.F90
  cart2frac.f
  cell_broyden_optim.F
  cell_fire_optim.F
  cellsubs.f
  cgvc.F
  cgvc_zmatrix.F
  cgwf.F
  chemical.f
  chempot.F
  chkdim.f
  chkgmx.f
  class_Data1D.F90
  class_Data1D.T90
  class_Data2D.F90
  class_Data2D.T90
  class_Data3D.F90
  class_Data3D.T90
  class_Distribution.F90
  class_Fstack_Data1D.F90
  class_Fstack_Pair_Data1D.F90
  class_Fstack_Pair_Geometry_SpData2D.F90
  class_Fstack_Pair_SpData1D.F90
  class_Geometry.F90
  class_OrbitalDistribution.F90
  class_Pair_Data1D.F90
  class_Pair_Geometry_SpData2D.F90
  class_Pair_SpData1D.F90
  class_SpData1D.F90
  class_SpData1D.T90
  class_SpData2D.F90
  class_SpData2D.T90
  class_SpData3D.F90
  class_SpData3D.T90
  class_Sparsity.F90
  class_TriMat.F90
  class_TriMat.T90
  cli_m.f90
  coceri.f
  compute_dm.F
  compute_ebs_shift.F90
  compute_energies.F90
  compute_max_diff.F90
  compute_norm.F
  compute_pw_matrix.F90
  ${PROJECT_BINARY_DIR}/Src/configured_values_m.F90
  conjgr.f
  conjgr_old.f
  constr.f
  coor.F
  coxmol.f
  cranknic_evolg.F90
  cranknic_evolk.F90
  create_Sparsity_SC.F90
  create_Sparsity_Union.F90
  cross.f
  debugmpi.F
  delk.F90
  denmat.F
  denmatlomem.F
  densematrix.f90
  detover.F
  dfscf.f
  dftu.F
  dftu_specs.f
  dhscf.F
  dhsdr_m.F90
  diag.F90
  diag2g.F
  diag2k.F
  diag2kp.F90
  diag2kspiral.F90
  diag3g.F
  diag3k.F
  diag3kp.F90
  diag_option.F90
  diagg.F
  diagk.F
  diagk_file.F
  diagkp.F
  diagkp_velocity.F90
  diag2kp_velocity.F90
  diag3kp_velocity.F90
  diagmemory.F
  diagon.F
  diagonalizeHk.F90
  diagpol.f
  digcel.f
  dipole.F90
  dismin.f
  dm_charge.F90
  dnaefs.F
  domain_decom.F
  doping_uniform.F
  dot.f
  dynamics.F
  egandd.F
  eggbox.F
  electrostatic.f
  ener3.F
  ener3lomem.F
  errorf.f
  extrae_eventllist.F90
  extrae_module.f90
  extrapolateSpData2D.F90
  extrapolon.f
  fc_matrices_m.F90
  fdf_extra.F90
  fermid.F
  fft.F
  fft1d.F
  fftw3_wrapper.F90
  files.f
  final_H_f_stress.F
  find_kgrid.F
  fire_optim.F
  flook_siesta.F90
  fold_auxcell.f90
  forhar.F
  fsiesta_mpi.F90
  fsockets.f90
  geom_helper.f90
  get_kpoints_scale.f90
  globalise.F
  gradient.F
  gradientlomem.F
  grimme_dispersion_m.F90
  grdsam.F
  hamann.f90
  hsparse.F
  idiag.f
  init_output.f90
  initatom.f
  initparallel.F
  interpolation.f90
  intrinsic_missing.F90
  inver.f
  io.f
  io_ext.f90
  io_sparse.F90
  iocg.f
  iodm.F
  iodm_netcdf.F90
  iodmhs_netcdf.F90
  ioeig.f
  iofa.f90
  iogrid_netcdf.F90
  iokp.f
  iolwf.F
  iomd.f
  iopipes.F90
  iosockets.F90
  iotdxv.F
  iowfs_netcdf.F90
  ioxv.F
  iozm.F
  ipack.f
  kgrid.F
  kgridinit.F
  kinefsm.F
  kpoint_convert.f90
  kpoint_dos.F90
  kpoint_ldos.F90
  kpoint_pdos.F90
  kpoint_scf.F90
  kpoint_t.F90
  ksv.f
  ksvinit.F
  linpack.F
  listsc.f
  local_DOS.F90
  m_broyddj.f90
  m_broyddj_nocomm.f90
  m_broyden_mixing.f
  m_cell.f
  m_char.f90
  m_charge_add.F90
  m_check_walltime.f90
  m_chempotwann.F90
  m_chess.F90
  m_cite.F90
  m_convergence.f90
  m_dftu_so.F90
  m_digest_nnkp.F90
  m_diis.F90
  m_dipol.F90
  m_dminim.F90
  m_dscfcomm.F
  m_efield.F90
  m_elsi_interface.F90
  m_energies.F90
  m_eo.F90
  m_evolve.F90
  m_exp_coord.F90
  m_fft_gpfa.F
  m_filter.f90
  m_fire.f90
  m_fire_mixing.f
  m_fire_para.F90
  m_fixed.F90
  m_forces.F90
  m_gauss_fermi_17.f90
  m_gauss_fermi_18.f90
  m_gauss_fermi_19.f90
  m_gauss_fermi_20.f90
  m_gauss_fermi_22.f90
  m_gauss_fermi_24.f90
  m_gauss_fermi_26.f90
  m_gauss_fermi_28.f90
  m_gauss_fermi_30.f90
  m_gauss_fermi_inf.f90
  m_gauss_quad.f90
  m_geom_aux.f90
  m_geom_box.f90
  m_geom_coord.f90
  m_geom_objects.f90
  m_geom_plane.f90
  m_geom_square.f90
  m_getopts.f90
  m_handle_sparse.F90
  m_hartree_add.F90
  io_hsx.F90
  m_initwf.F90
  m_integrate.f90
  m_interpolate.F90
  m_inversemm.F90
  m_io.f
  m_io_yaml.F90
  m_iodipol.F90
  m_iodm.F90
  m_iodm_old.F
  m_iorho.F
  m_iostruct.f
  m_iotddft.F90
  m_iterator.f90
  m_kinetic.F90
  m_mat_invert.F90
  m_matdiag.F90
  m_matio.F90
  m_matswinvers.F90
  m_mesh_node.F90
  m_mixing.F90
  m_mixing_scf.F90
  m_monitor.F90
  m_mpi_utils.F
  m_ncdf_siesta.F90
  m_new_dm.F90
  m_noccbands.f
  m_ntm.F90
  m_occ_proj_dftu.F90
  m_options.f90
  m_orderbands.F
  m_os.F90
  m_overkkneig.F90
  partial_charges.F90
  m_pivot.F90
  m_pivot_array.f90
  m_pivot_methods.F90
  m_planewavematrix.F90
  m_planewavematrixvar.F90
  m_pot_dftu.F90
  m_redist_spmatrix.F90
  m_region.F90
  m_rhog.F90
  m_rmaxh.F90
  m_sparse.F90
  m_sparsity_handling.F90
  m_spin.F90
  m_steps.F90
  m_stress.F90
  m_supercell.F90
  m_svd.F90
  m_switch_local_proj.F90
  m_target_stress.F90
  m_test_io.F90
  m_timer.F90
  m_transiesta.F90
  m_trialorbitalclass.f90
  m_trimat_invert.F90
  m_ts_aux.F90
  m_ts_cctype.f90
  m_ts_chem_pot.F90
  m_ts_contour.f90
  m_ts_contour_eq.f90
  m_ts_contour_neq.f90
  m_ts_debug.F90
  m_ts_dm_update.F90
  m_ts_elec_se.F90
  m_ts_electrode.F90
  m_ts_full_scat.F90
  m_ts_fullg.F90
  m_ts_fullk.F90
  m_ts_gf.F90
  m_ts_global_vars.f90
  m_ts_hartree.F90
  ts_io_hs.F90
  m_ts_io_contour.f90
  m_ts_io_ctype.f90
  m_ts_iodm.F90
  m_ts_method.f90
  m_ts_mumps_init.F90
  m_ts_mumps_scat.F90
  m_ts_mumpsg.F90
  m_ts_mumpsk.F90
  m_ts_options.F90
  m_ts_pivot.F90
  m_ts_rgn2trimat.F90
  m_ts_sparse.F90
  m_ts_sparse_helper.F90
  m_ts_tdir.f90
  m_ts_tri_common.F90
  m_ts_tri_init.F90
  m_ts_tri_scat.F90
  m_ts_trig.F90
  m_ts_trik.F90
  m_ts_trimat_invert.F90
  m_ts_voltage.F90
  m_ts_weight.F90
  m_uuid.f90
  m_vee_integrals.F90
  m_wallclock.f90
  m_walltime.f90
  m_wannier_in_nao.F90
  m_w90_wrapper.F90
  m_writedelk.F
  m_zminim.F90
  madelung.f
  matel.F90 matel_params.f90 matel_registry.F90 matel_table.F90 matel_ylm.F90
  md_out.F90
  memory.F
  memory_all.F90
  memory_log.F90
  memory_snapshot.f90
  mesh.F
  meshcomm.F
  meshdscf.F
  meshphi.F
  meshsubs.F
  metaforce.F
  minvec.f
  mixer.F
  mmio.F
  mmn.F90
  mneighb.f
  molecularmechanics.F90
  moments.F
  moreParallelSubs.F90
  moremeshsubs.F
  mulliken.F
  naefs.F
  nag.f
  ncdf_io.F90
  nlefsm.f
  normalize_dm.F90
  obc.f
  object_debug.F90
  ofc.f90
  on_subs.F
  onmod.F
  optical.F
  ordern.F
  outcell.f
  outcoor.f
  overfsm.f90
  overlap.f
  parallel.F
  parallelsubs.F
  parsing.f
  pdos.F90
  pdos2g.F90
  pdos2k.F90
  pdos2kp.F90
  pdos3g.F90
  pdos3k.F90
  pdos3kp.F90
  pdosg.F90
  pdosk.F90
  pdoskp.F90
  periodic_table.f
  phirphi.f
  phirphi_opt.f
  pixmol.f
  plcharge.F
  poison.F
  posix_calls.f90
  post_scf_work.F
  precision.F
  print_spin.F90
  printmatrix.F
  projected_DOS.F90
  propor.f
  proximity_check.F
  pspltm1.F
  pxf.F90
  qmmm/qmmm_core.f90
  qmmm/qmmm_ewald.f90
  qmmm/qmmm_helpers.f90
  qmmm/qmmm_interface.F90
  qmmm/qmmm_mmforces.F90
  qmmm/qmmm_mneighb.f90
  qmmm/qmmm_pcpot.F90
  qmmm/qmmm_structure.f90
  qsort.F
  radfft.f
  radial.f
  randomg.f90
  read_options.F90
  read_xc_info.F
  reclat.f
  redcel.F
  register_rfs.F90
  reinit_m.F90
  remove_intramol_pressure.f90
  reoptical.F
  reord.f
  reordpsi.F
  restructSpData2D.F90
  rhofft.F
  rhooda.F
  rhoofd.F90
  rhoofdsp.F90
  runinfo_m.F90
  rusage.f90
  sankey_change_basis.F90
  save_density_matrix.F90
  savepsi.F
  scfconvergence_test.F
  schecomm.F
  setatomnodes.F
  setspatial.f
  setup_H0.F
  setup_hamiltonian.F
  setup_ordern_indexes.F90
  shaper.f
  show_distribution.f
  siesta2wannier90.F90
  siesta_analysis.F90
  siesta_cml.f90
  siesta_cmlsubs.F90
  siesta_dicts.F90
  siesta_end.F
  siesta_forces.F90
  siesta_geom.F90
  siesta_handlers_m.F90
  siesta_init.F
  siesta_master.f90
  siesta_move.F
  siesta_options.F90
  option_charges.f90
  siesta_tddft.F90
  siesta_version_info.F90
  sockets.c
  sorting.f
  sparse_matrices.F90
  spatial.F
  spher_harm.f
  spin_subs.F90
  spinorbit.f
  state_analysis.F
  state_init.F
  struct_init.F
  timer.F90
  timer_tree.f90
  timestamp.f90
  transition_rate.F
  ts_charge.F90
  ts_dq.F90
  ts_energies.F90
  ts_electrode.F90
  ts_init.F90
  ts_kpoint_scf.F90
  ts_show_regions.f90
  typecell.f
  uncell.f
  vacuum_level.f90
  velocity_shift.F90
  vmat.F90
  vmatsp.F90
  vmb.F
  volcel.f
  wannier90_types.f
  w90_wrapper_types.f
  wavefunctions.F90
  write_inp_wannier.F90
  write_md_record.F
  write_orb_indx.f90
  write_raw_efs.f90
  write_subs.F
  writewave.F
  xml.f
  zm_broyden_optim.F
  zm_fire_optim.F
  zmatrix.F
)

if( SIESTA_WITH_PROFILE_NVTX )
  list(APPEND libsiesta_sources nvtx-profiling/nvtx_wrapper.F90)
  set_source_files_properties(
             timer.F90
             nvtx-profiling/nvtx_wrapper.F90
             PROPERTIES  COMPILE_DEFINITIONS "__PROFILE_NVTX")
  if ("${SIESTA_PROFILE_NVTX_LIBRARY}" STREQUAL "")
     message(WARNING "SIESTA_PROFILE_NVTX_LIBRARY is not defined. Will not profile")
     list(APPEND libsiesta_sources nvtx-profiling/dummy_nvtx.c)
  endif()

endif()

if( SIESTA_WITH_PEXSI )
  list(APPEND libsiesta_sources

    pexsi-solver/m_pexsi.F90
    pexsi-solver/m_pexsi_dos.F90
    pexsi-solver/m_pexsi_driver.F90
    pexsi-solver/m_pexsi_local_dos.F90
    pexsi-solver/siesta_pexsi_interface.F90
 )
endif()

# Create libsiesta target.
siesta_add_library(${PROJECT_NAME}.libsiesta
    ${libsiesta_sources}
  EXPORT_NAME libsiesta
  OUTPUT_NAME siesta
  CUSTOM_TARGET libsiesta
  NAMESPACE_TARGET libsiesta)

target_compile_definitions(${PROJECT_NAME}.libsiesta
  PUBLIC
  $<$<BOOL:${SIESTA_WITH_MPI}>:MPI>
  $<$<BOOL:${SIESTA_WITH_GRID_SP}>:GRID_SP>
  $<$<BOOL:${SIESTA_WITH_ELPA}>:SIESTA__ELPA>
  $<$<BOOL:${SIESTA_WITH_PEXSI}>:SIESTA__PEXSI>
  $<$<BOOL:${SIESTA_WITH_CHESS}>:SIESTA__CHESS>
  $<$<BOOL:${SIESTA_WITH_ELSI}>:SIESTA__ELSI>
  $<$<BOOL:${ELSI_HAS_PEXSI}>:ELSI_HAS_PEXSI>
  $<$<BOOL:${ELSI_HAS_MAGMA}>:ELSI_HAS_MAGMA>
  $<$<BOOL:${ELSI_HAS_EIGENEXA}>:ELSI_HAS_EIGENEXA>
  $<$<BOOL:${ELSI_HAS_SIPS}>:ELSI_HAS_SIPS>
  $<$<BOOL:${ELSI_HAS_EXTERNAL_ELPA}>:ELSI_HAS_EXTERNAL_ELPA>
  $<$<NOT:$<BOOL:${ELSI_HAS_EXTERNAL_ELPA}>>:ELPA_API_VERSION=20200000>
  $<$<BOOL:${SIESTA_WITH_NETCDF}>:CDF>
  $<$<BOOL:${SIESTA_WITH_NCDF}>:NCDF NCDF_4>
  $<$<BOOL:${SIESTA_WITH_NCDF_PARALLEL}>:NCDF_PARALLEL>
  $<$<BOOL:${SIESTA_WITH_FFTW}>:SIESTA__FFTW>
  $<$<BOOL:${SIESTA_WITH_FLOOK}>:SIESTA__FLOOK>
  $<$<BOOL:${SIESTA_WITH_DFTD3}>:SIESTA__DFTD3>
  $<$<BOOL:${SIESTA_WITH_WANNIER90}>:SIESTA__WANNIER90>
)

# CMake linking order I do not understand
# The xmlf90 order seems important, but it shouldn't be since
# cmake should be able to determine correct dependency order.
# 1. xmlf90 before libpsml does not work
# 2. xmlf90 after libpsml works
# 3. removing xmlf90 works, since libpsml depends on xmlf90 (see top-level CMakeLists.txt)
# Huh..?
#
# A similar issue arises when the NetCDF installation is compiled with MPI capability. The
# order of the mpi_siesta (or MPI::MPI_Fortran in general) and the NetCDF targets is significant.
# For example, in CINECA with intel-oneapi-mpi and the GNU compiler, if NetCDF comes first the
# intel-specific 'include' directory is put first in the '-I' list by CMake, instead of the
# 'include/gfortran/<version-number>' directory. Putting the MPI dependency first seems to fix
# the issue.
#
if(SIESTA_WITH_ELPA AND (NOT SIESTA_HAS_ELPA_THROUGH_ELSI))
  set(SIESTA_NEEDS_ELPA_TARGET TRUE)
else()
  set(SIESTA_NEEDS_ELPA_TARGET FALSE)
endif()
message(STATUS "SIESTA_NEEDS_ELPA_TARGET: ${SIESTA_NEEDS_ELPA_TARGET}")

target_link_libraries(${PROJECT_NAME}.libsiesta
  PUBLIC
  $<$<BOOL:${SIESTA_WITH_MPI}>:${PROJECT_NAME}.mpi>
  $<$<BOOL:${SIESTA_WITH_NCDF}>:${PROJECT_NAME}.libncdf>
  $<$<BOOL:${SIESTA_WITH_NETCDF}>:NetCDF::NetCDF_Fortran>

=== Tests/CMakeLists.txt ===
# This is the main engine for SIESTA tests.
# We should probably leave only the "simple" tests as the default
# without their output verification. This can be done by choosing
# the appropriate tests when making the cmake targets (maybe via labels?)

# TODO
# Instead of doing everything in CMake, first running, then checking.
# It would be better to control the 2nd run in a wrapper executable.
# This executable would run siesta, then check.
# That would also remove the problem of labels for tests.

# Include the tests setup scripts that define
# the required test variables/functions.
include(tests/SiestaTests)

# TODO consider changing this to a fixture.
file(
  COPY
    test-cfg.yml
    out_digest_yaml.awk
    yaml_compare.py
  DESTINATION
    "${SIESTA_TESTS_BINARY_DIR}"
)


list(APPEND CMAKE_MESSAGE_CONTEXT test)
message(STATUS "Default pseudo directory for tests: ${SIESTA_TESTS_PSEUDO_DIR}")

# Checking the output files requires Python3
# The siesta_verifyout function may break
# if Python 3 cannot be located!
find_package(Python3
  3.5.0 # subprocess limitation
  COMPONENTS Interpreter
  )

# TODO add check for import of the ruamel.yaml package.


add_subdirectory(00.BasisSets)
add_subdirectory(01.PseudoPotentials)
add_subdirectory(02.SpinPolarization)
add_subdirectory(03.SpinOrbit)
add_subdirectory(04.SCFMixing)
add_subdirectory(05.Bands)
add_subdirectory(06.DensityOfStates)
add_subdirectory(07.ForceConstants)
add_subdirectory(08.GeometryOptimization)
add_subdirectory(09.MolecularDynamics)
add_subdirectory(10.Functionals)
add_subdirectory(11.ElectronicProperties)
add_subdirectory(12.Solvers)
add_subdirectory(13.MiscOptions)
add_subdirectory(14.FileIO)
add_subdirectory(15.TDDFT)
add_subdirectory(16.TranSiesta)

add_subdirectory(17.Wannier90)
add_subdirectory(Dependency_Tests)
add_subdirectory(Unit_Tests)

# Pop back the test context
list(POP_BACK CMAKE_MESSAGE_CONTEXT)

=== External/Wannier/CMakeLists.txt ===
if (NOT TARGET wrapper-wannier90::wrapper-wannier90)

  set(CMAKE_PROJECT_wrapper-wannier90_INCLUDE_BEFORE
         "${PROJECT_SOURCE_DIR}/External/Options/options_wrapper-wannier90.cmake")
	 
  # Location of wannier90-3.1.0.tar.gz package
  # It can be a local file or a remote URL
  
  if(NOT "$ENV{WANNIER90_PACKAGE}" STREQUAL "")
       set(url "$ENV{WANNIER90_PACKAGE}")
  elseif(EXISTS
     "${PROJECT_SOURCE_DIR}/External/Wannier/wrapper-wannier90/LICENSE")
     #
     # We assume that we have somehow put the pristine source in this directory
     # (perhaps using a submodule -- but do not 'init' it by default,
     # as it is huge -- cloned directory is over 170Mb)
     # Better ship tar.gz file around
     #
     set(url "${PROJECT_SOURCE_DIR}/External/Wannier/wrapper-wannier90")

  elseif(EXISTS
     "${PROJECT_SOURCE_DIR}/External/Wannier/patched_wrapper-wannier90/CMakeLists.txt")

    # Intended for developers
    message(STATUS "Adding External/Wannier/patched_wrapper-wannier90 subdirectory...")
    message(STATUS "... containing already-patched sources for w90 wrapper")

    add_subdirectory("${PROJECT_SOURCE_DIR}/External/Wannier/patched_wrapper-wannier90")
    add_library("wrapper-wannier90::wrapper-wannier90" ALIAS "wrapper-wannier90-lib")
    RETURN()
    
  else()

    set(url "https://github.com/wannier-developers/wannier90/archive/v3.1.0.tar.gz")
    
    message(STATUS "About to download the Wannier90 source package")
    message(STATUS "If download is not possible, or too heavy:")
    message(STATUS " Please set environment variable WANNIER90_PACKAGE")
    message(STATUS " to point to a pristine (possibly remote) wannier90-3.1.0.tar.gz package,")
    message(STATUS " or populate ${PROJECT_SOURCE_DIR}/External/Wannier/wrapper-wannier90/")
    message(STATUS " with a pristine wannier90 v3.1.0 src/ directory plus the LICENSE file,")
    message(STATUS " or populate ${PROJECT_SOURCE_DIR}/External/Wannier/patched_wrapper-wannier90/")
    message(STATUS " with the already patched w90 wrapper sources")

  endif()
  
  set(package "wrapper-wannier90")
  message(STATUS "Retrieving pristine sources for wannier90-3.1.0 from ${url}")
  include(FetchContent)

  # Common declaration for both approaches
  FetchContent_Declare(wrapper-wannier90
    DOWNLOAD_EXTRACT_TIMESTAMP true
    PATCH_COMMAND patch -p1 -i ${PROJECT_SOURCE_DIR}/External/Wannier/Patches/3.1.0.patch
    UPDATE_DISCONNECTED true
    UPDATE_COMMAND ""
    URL "${url}"
    URL_HASH SHA256=40651a9832eb93dec20a8360dd535262c261c34e13c41b6755fa6915c936b254
  )

  # Use modern approach for CMake 3.24+ (when FetchContent_MakeAvailable got more robust)
  # Use traditional approach for older versions to ensure patch safety
  if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.24")
    message(STATUS "Using modern FetchContent_MakeAvailable approach (CMake ${CMAKE_VERSION})")
    FetchContent_MakeAvailable(wrapper-wannier90)
  else()
    # Slightly indirect way to avoid re-patching if CMake is invoked again.
    # The call to _Populate, as opposed to _MakeAvailable, seems not to
    # apply the patching step a second time...
    # (set -DFETCHCONTENT_QUIET=OFF to see the internal messages)
    message(STATUS "Using traditional FetchContent approach for compatibility (CMake ${CMAKE_VERSION})")
    
    FetchContent_GetProperties(wrapper-wannier90)
    if(NOT wrapper-wannier90_POPULATED)
      # Fetch the content using previously declared details
      message(STATUS "Making-available ${package}...")
      FetchContent_Populate(wrapper-wannier90)

      # Set custom variables, policies, etc.
      # ...
    endif()

    # Bring the populated content into the build
    message(STATUS "Adding subdirectory ${wrapper-wannier90_SOURCE_DIR}")
    add_subdirectory("${wrapper-wannier90_SOURCE_DIR}" "${wrapper-wannier90_BINARY_DIR}")
  endif()

  # The wrapper-wannier90::wrapper-wannier90 target is not defined in the
  # subproject until installation time. Hence the need for the
  # following lines.
  # Note the GLOBAL qualifier, since this is in a subordinate scope
  # I am not sure about the interpretation of 'wrapper-wannier90'
  # in the second line.
  
  add_library(wrapper-wannier90::wrapper-wannier90 INTERFACE IMPORTED GLOBAL)
  target_link_libraries(wrapper-wannier90::wrapper-wannier90 INTERFACE wrapper-wannier90)

  # We need the module directory in the subproject before we finish the configure stage
  FetchContent_GetProperties(${package} BINARY_DIR WRAPPER_WANNIER90_BINARY_DIR)
  if(NOT EXISTS "${WRAPPER_WANNIER90_BINARY_DIR}/include")
     make_directory("${WRAPPER_WANNIER90_BINARY_DIR}/include")
  endif()

endif()

=== Src/MPI/CMakeLists.txt ===
#
# When to use the legacy interfaces:
#
#    When mpi_f08 is not available or wanted and
#    the compiler is able to process them. If it is not
#    (e.g. some versions of nvhpc), SIESTA_WITH_MPI_EMPTY_INTERFACES
#    should be defined.
#
#

# Create the MPI mpi_macros.f interface library.
# This just simplifies the usage of the
#  #include "mpi_macros.f"
# in the files.
add_library(${PROJECT_NAME}.mpi_macros INTERFACE)

if( SIESTA_WITH_MPI )
  # Real mpi_macros.f
  target_include_directories(${PROJECT_NAME}.mpi_macros
    INTERFACE
    ${PROJECT_SOURCE_DIR}/Src/MPI
  )
else()
  # fake mpi_macros.f
  target_include_directories(${PROJECT_NAME}.mpi_macros
    INTERFACE
    ${PROJECT_SOURCE_DIR}/Src/MPI/stub
  )

  # Quick-return to not do anything
  return()
endif()


if(SIESTA_WITH_MPI_INTERFACES STREQUAL "legacy")
    set(SIESTA_USES_MPI_LEGACY_INTERFACES ON)
else()
    set(SIESTA_USES_MPI_LEGACY_INTERFACES OFF)
endif()

message(STATUS "SIESTA_USES_MPI_LEGACY_INTERFACES: ${SIESTA_USES_MPI_LEGACY_INTERFACES}")

if (NOT SIESTA_USES_MPI_LEGACY_INTERFACES)

  siesta_add_library(${PROJECT_NAME}.mpi
    NO_LINKER_FLAGS
    OBJECT
    mpi_siesta.F90
  )

else()

  siesta_add_library(${PROJECT_NAME}.mpi
    NO_LINKER_FLAGS
    OBJECT

    # Sources
    mpi_siesta.F90
    mpi_interfaces.F90
    mpi__include.f90
    Interfaces_integer.f90
    Interfaces.f90
  )
  # We need to find "Interfaces.f90", which is generated in the build
  #("binary") directory, so we need to add this directory to the list

  target_include_directories(${PROJECT_NAME}.mpi
    PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

endif()

string(TOUPPER ${SIESTA_WITH_MPI_INTERFACES} INTERFACE_upper)
set(VAR_MPI_INTERFACE "MPI_INTERFACE_${INTERFACE_upper}")
message(STATUS "Variable for preprocessing MPI interfaces: ${VAR_MPI_INTERFACE}")

target_compile_definitions(
  ${PROJECT_NAME}.mpi
  PUBLIC
  "$<$<BOOL:${SIESTA_WITH_GRID_SP}>:GRID_SP>"
  "${VAR_MPI_INTERFACE}"
)

target_link_libraries(${PROJECT_NAME}.mpi
  PUBLIC MPI::MPI_Fortran
  INTERFACE ${PROJECT_NAME}.mpi_macros
)

# So that clients of ${PROJECT_NAME}.mpi can find its modules:
target_include_directories(${PROJECT_NAME}.mpi
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR} # for created files
)


if (SIESTA_USES_MPI_LEGACY_INTERFACES)
  # Handling of interface-generation script
  # These generation scripts do not work with the suffix for the executables
  siesta_suffix(
    NEW ""
    VARIABLES EXECUTABLE)


  # Create integer kinds and interfaces
  siesta_add_executable(${PROJECT_NAME}.mpi_int_explorer
    # Do not default to build this one, it is only
    # a temporary build dependency
    EXCLUDE_FROM_ALL
    int_explorer.f90
  )


  list(JOIN SIESTA_INTEGER_KINDS " " SIESTA_INTEGER_KINDS_STR)
  add_custom_command(
    OUTPUT Interfaces_integer.f90
    # Dependency targets
    DEPENDS ${PROJECT_NAME}.mpi_int_explorer
    COMMAND sh "${CMAKE_CURRENT_SOURCE_DIR}/generate_integer.sh" ${SIESTA_INTEGER_KINDS_STR}
    VERBATIM
    COMMENT "Creating MPI interfaces and modules for integer kinds"
  )


  # Create real kinds and interfaces
  siesta_add_executable(${PROJECT_NAME}.mpi_kind_explorer
    EXCLUDE_FROM_ALL
    kind_explorer.f90
  )

  list(JOIN SIESTA_REAL_KINDS " " SIESTA_REAL_KINDS_STR)
  add_custom_command(
    OUTPUT Interfaces.f90
    DEPENDS ${PROJECT_NAME}.mpi_kind_explorer
    COMMAND sh "${CMAKE_CURRENT_SOURCE_DIR}/generate_real.sh" ${SIESTA_REAL_KINDS_STR}
    VERBATIM
    COMMENT "Creating MPI interfaces and modules for real, character and logical"
  )

  # Restore the old suffix before using this one.
  siesta_suffix(
    POP
    VARIABLES EXECUTABLE
  )
endif()

=== Src/easy-ncdf/CMakeLists.txt ===
#
# Use a pre-generated source file (see top of file)
#
siesta_add_library(
  ${PROJECT_NAME}.libncdf
  NO_LINKER_FLAGS
  STATIC 
    netcdf_ncdf.F90
  )

if(SIESTA_WITH_NCDF_PARALLEL)
  target_compile_definitions(
    ${PROJECT_NAME}.libncdf
    PRIVATE
    NCDF_PARALLEL
  )

  # Note that libncdf uses the MPI module directly, through 'use mpi'
  # This dependency has been put first to avoid problems with some
  # MPI installations (e.g. when using oneapi-mpi with the GNU compiler in CINECA)

  target_link_libraries(
     ${PROJECT_NAME}.libncdf
     PRIVATE
     MPI::MPI_Fortran
  )

endif()

target_link_libraries(
   ${PROJECT_NAME}.libncdf
   # 'PUBLIC' to bring in fdict
   PRIVATE
   ${PROJECT_NAME}.libfdict
   NetCDF::NetCDF_Fortran
)

target_include_directories(
  ${PROJECT_NAME}.libncdf
  INTERFACE
  ${CMAKE_CURRENT_BINARY_DIR}
)

=== Tests/09.MolecularDynamics/CMakeLists.txt ===
#
siesta_subtest(verlet LABELS simple)
siesta_subtest(anneal FILES_CLEANUP anneal.ANNEAL_RESTART)
siesta_subtest(anneal_pt FILES_CLEANUP anneal_pt.ANNEAL_RESTART)
siesta_subtest(nose)
siesta_subtest(pr)
siesta_subtest(npr)
siesta_subtest(npr_rip)

siesta_subtest(verlet_restart    NAME_ALTER verlet_rst    FILES_SETUP verlet.XV verlet.VERLET_RESTART LABELS simple)
siesta_subtest(anneal_restart    NAME_ALTER anneal_rst    FILES_SETUP anneal.XV anneal.ANNEAL_RESTART)
siesta_subtest(anneal_pt_restart NAME_ALTER anneal_pt_rst FILES_SETUP anneal_pt.XV anneal_pt.ANNEAL_RESTART)
siesta_subtest(nose_restart      NAME_ALTER nose_rst      FILES_SETUP nose.XV nose.NOSE_RESTART)
siesta_subtest(pr_restart        NAME_ALTER pr_rst        FILES_SETUP pr.XV pr.PR_RESTART)
siesta_subtest(npr_restart       NAME_ALTER npr_rst       FILES_SETUP npr.XV npr.NPR_RESTART)
siesta_subtest(npr_rip_restart   NAME_ALTER npr_rip_rst   FILES_SETUP npr_rip.XV npr_rip.NPR_RESTART)

siesta_subtest(verlet_restart    NAME_ALTER verlet_rstxv    FILES_SETUP verlet.XV FILES_CLEANUP verlet.VERLET_RESTART LABELS simple)
siesta_subtest(anneal_restart    NAME_ALTER anneal_rstxv    FILES_SETUP anneal.XV FILES_CLEANUP anneal.ANNEAL_RESTART)
siesta_subtest(anneal_pt_restart NAME_ALTER anneal_pt_rstxv FILES_SETUP anneal_pt.XV FILES_CLEANUP anneal_pt.ANNEAL_RESTART)
siesta_subtest(nose_restart      NAME_ALTER nose_rstxv      FILES_SETUP nose.XV FILES_CLEANUP nose.NOSE_RESTART)
siesta_subtest(pr_restart        NAME_ALTER pr_rstxv        FILES_SETUP pr.XV FILES_CLEANUP pr.PR_RESTART)
siesta_subtest(npr_restart       NAME_ALTER npr_rstxv       FILES_SETUP npr.XV FILES_CLEANUP npr.NPR_RESTART)
siesta_subtest(npr_rip_restart   NAME_ALTER npr_rip_rstxv   FILES_SETUP npr_rip.XV FILES_CLEANUP npr_rip.NPR_RESTART)

=== Tests/10.Functionals/CMakeLists.txt ===
#

siesta_subtest(lyp)
siesta_subtest(pbe LABELS simple)
siesta_subtest(pbesol)
siesta_subtest(am05)
siesta_subtest(vdw_vv)
siesta_subtest(vdw_drsll)
siesta_subtest(c6)
siesta_subtest(ldau LABELS simple)
siesta_subtest(dftu_soc)
siesta_subtest(h2o_qmmm)

=== Tests/15.TDDFT/CMakeLists.txt ===
#

siesta_subtest(TDDFT_h2o1 LABELS simple)
siesta_subtest(TDDFT_h2o2 FILES_SETUP TDDFT_h2o.DM  TDDFT_h2o.TDWF  TDDFT_h2o.TDXV  TDDFT_h2o.XV LABELS simple)

=== Tests/Dependency_Tests/CMakeLists.txt ===

if(SIESTA_WITH_DFTD3)
  siesta_subtest(dftd3 LABELS simple)
endif()

# This test might fail if LUA is not present.
if(SIESTA_WITH_FLOOK)
  siesta_subtest(lua_h2o FILES_SETUP siesta.lua)
endif()

=== Tests/Unit_Tests/CMakeLists.txt ===

add_executable(
  test-citations
  test_citations.f90
  ${PROJECT_SOURCE_DIR}/Src/m_cite.F90
)

file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/unit_tests")

add_test(  NAME    citations-test
           COMMAND $<TARGET_FILE:test-citations>
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/unit_tests"
	)

set_property (TEST citations-test
              PROPERTY PASS_REGULAR_EXPRESSION "0953-8984")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=siesta
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.4.1
pkgrel=1
pkgdesc="A first-principles materials simulation code using DFT. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://siesta-project.org/siesta'
msys2_repository_url="https://gitlab.com/siesta-project/siesta"
msys2_references=(
  'aur: siesta'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-s-dftd3"
         "${MINGW_PACKAGE_PREFIX}-libfdf"
         "${MINGW_PACKAGE_PREFIX}-libgridxc"
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-mctc-lib"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-scalapack"
         "${MINGW_PACKAGE_PREFIX}-xmlf90")
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python")
_w90_ver=3.1.0
source=("https://gitlab.com/siesta-project/siesta/-/releases/${pkgver}/downloads/${_realname}-${pkgver}.tar.gz"
        "https://github.com/wannier-developers/wannier90/archive/v${_w90_ver}/wannier90-${_w90_ver}.tar.gz"
        "001-fix-build-on-mingw.patch")
sha256sums=('531ed2fa021d6a733739b5c1ba7d8cf32fe5aee3df6774a8e748ba3d6faaebcc'
            '40651a9832eb93dec20a8360dd535262c261c34e13c41b6755fa6915c936b254'
            '6c5c587e1b66b94391e090688edc36daca9033360113148df4a5c43b8f619752')
noextract=("wannier90-${_w90_ver}.tar.gz")

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  local _fflags=""
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _fflags+=" -fallow-invalid-boz"
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _fflags+=" -march=x86-64-v3"
    CFLAGS+=" -march=x86-64-v3"
  fi

  FFLAGS="${_fflags}" \
  WANNIER90_PACKAGE="${srcdir}"/wannier90-${_w90_ver}.tar.gz \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DSIESTA_SHARED_LIBS=ON \
      -DSIESTA_WITH_ELPA=OFF \
      -DSIESTA_WITH_ELSI=OFF \
      -DSIESTA_WITH_FLOOK=OFF \
      -DSIESTA_WITH_IPO=OFF \
      -DSIESTA_SET_RPATH=OFF \
      -DSIESTA_WITH_FFTW=ON \
      -DSIESTA_WITH_LIBXC=ON \
      -DSIESTA_WITH_MPI=ON \
      -DSIESTA_WITH_NETCDF=ON \
      -DSIESTA_WITH_OPENMP=ON \
      -DSIESTA_WITH_WANNIER90=ON \
      -DSIESTA_TESTS=OFF \
      -DBLA_VENDOR=OpenBLAS \
      -DSCALAPACK_LIBRARY=${MINGW_PREFIX}/lib/libscalapack.dll.a \
      -DFortran_FLAGS_RELEASE="-O3" \
      -DC_FLAGS_RELEASE="-O3" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
